<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="DoxyPress 1.2.10"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Accessories: D:/Mes documents/Trusty/Arduino/Libraries/Accessories/src/Accessories.cpp Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
  $(window).load(resizeHeight);
</script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { init_search(); });
</script>
<link href="doxypress.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by DoxyPress -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Accessories
   </div>
   <div id="projectbrief">Arduino for motors and lights library.</div>
  </td>
   <td>        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
</td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by DoxyPress 1.2.10 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('Accessories_8cpp_source.html','');});
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">Accessories.cpp</div>  </div>
  <div class="clear-floats"></div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">/*************************************************************</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment">project: &lt;Accessories&gt;</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment">author: &lt;Thierry PARIS&gt;</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment">description: &lt;Base functions of the library&gt;</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment">*************************************************************/</span></div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;</div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="preprocessor">#include &quot;Accessories.hpp&quot;</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="preprocessor">#include &quot;ActionsStack.hpp&quot;</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="preprocessor">#ifndef NO_EEPROM</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="preprocessor">#include &quot;EEPROM.h&quot;</span></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="preprocessor">#include &quot;AccessoriesCircularBuffer.hpp&quot;</span></div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;</div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="keywordtype">bool</span> Accessories::SerialStarted = <span class="keyword">false</span>;</div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> Accessories::WaitEndDate = 0;</div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="preprocessor">#ifndef NO_EEPROM</span></div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="keywordtype">int</span> Accessories::EEPROMStart = -1;</div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="keywordtype">int</span> Accessories::EEPROMSize = -1;</div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="keywordtype">int</span> Accessories::EEPROMRecordSize = 0;</div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> Accessories::EEPROMStartingDelay = 0;</div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<a class="code" href="classAccessoriesCircularBuffer.html">AccessoriesCircularBuffer</a> Accessories::circularBuffer;</div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;</div><div class="line"><a name="l00024"></a><span class="lineno"><a class="line" href="classAccessories.html#abf6c53a430ca7986f9acfc5b222cbc31">   24</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="classAccessories.html#abf6c53a430ca7986f9acfc5b222cbc31">Accessories::begin</a>(<span class="keywordtype">int</span> inEEPROMStart, <span class="keywordtype">int</span> inEEPROMSize)</div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;{</div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;    SerialStarted = <span class="keyword">true</span>;</div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;</div><div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;<span class="preprocessor">#ifndef NO_EEPROM</span></div><div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;    Accessories::EEPROMStart = inEEPROMStart;</div><div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;    Accessories::EEPROMSize = inEEPROMSize;</div><div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;    Accessories::EEPROMStartingDelay = 0;</div><div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;</div><div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;<span class="preprocessor">#ifdef ACCESSORIES_DEBUG_MODE</span></div><div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;    <span class="comment">// Just for let the time to the PIC to initialize internals...</span></div><div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;    delay(500);</div><div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;</div><div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;    Serial.println(F(<span class="stringliteral">&quot;&quot;</span>));</div><div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;    Serial.println(F(<span class="stringliteral">&quot;Accessories V1.0.1&quot;</span>));</div><div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;    Serial.println(F(<span class="stringliteral">&quot;Developed by Thierry Paris.&quot;</span>));</div><div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;    Serial.println(F(<span class="stringliteral">&quot;(c) Locoduino 2016-2017&quot;</span>));</div><div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;    Serial.println(F(<span class="stringliteral">&quot;&quot;</span>));</div><div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;</div><div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;    Serial.println(F(<span class="stringliteral">&quot;*** Setup Accessories started.&quot;</span>));</div><div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;</div><div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;<span class="preprocessor">#ifndef NO_EEPROM</span></div><div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;    <span class="keywordflow">if</span> (EEPROMStart + EEPROMSize != -2 &amp;&amp; (EEPROMSize == -1 || EEPROMStart == -1))</div><div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;    {</div><div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;        Serial.print(F(<span class="stringliteral">&quot;   Error : EEPROM will not be used : &quot;</span>));</div><div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;        Serial.println(F(<span class="stringliteral">&quot;   EEPROMSize or EEPROMStart is not defined by begin.&quot;</span>));</div><div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;    }</div><div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;}</div><div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;</div><div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;<span class="preprocessor">#ifdef ACCESSORIES_DEBUG_MODE</span></div><div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;<span class="keywordtype">void</span> Accessories::printEvent(<span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> inId, ACCESSORIES_EVENT_TYPE inEventType, <span class="keywordtype">int</span> inEventData)</div><div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;{</div><div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;    Serial.print(F(<span class="stringliteral">&quot;Commander event : Address : &quot;</span>));</div><div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;    Serial.print(inId, DEC);</div><div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;    Serial.print(F(<span class="stringliteral">&quot; / &quot;</span>));</div><div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;    <span class="keywordflow">switch</span> (inEventType)</div><div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;    {</div><div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;    <span class="keywordflow">case</span> ACCESSORIES_EVENT_NONE:            Serial.println(F(<span class="stringliteral">&quot;NONE&quot;</span>));      <span class="keywordflow">break</span>;</div><div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;    <span class="keywordflow">case</span> ACCESSORIES_EVENT_TOGGLE:      Serial.println(F(<span class="stringliteral">&quot;TOGGLE&quot;</span>));    <span class="keywordflow">break</span>;</div><div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;    <span class="keywordflow">case</span> ACCESSORIES_EVENT_MOVE:</div><div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;        Serial.print(F(<span class="stringliteral">&quot;MOVE &quot;</span>));</div><div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;        <span class="keywordflow">switch</span> ((ACCESSORIES_MOVE_TYPE)inEventData)</div><div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;        {</div><div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;        <span class="keywordflow">case</span> ACCESSORIES_MOVE_MORE:     Serial.println(F(<span class="stringliteral">&quot;MORE&quot;</span>));      <span class="keywordflow">break</span>;</div><div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;        <span class="keywordflow">case</span> ACCESSORIES_MOVE_LESS:     Serial.println(F(<span class="stringliteral">&quot;LESS&quot;</span>));      <span class="keywordflow">break</span>;</div><div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;        <span class="keywordflow">case</span> ACCESSORIES_MOVE_STOP:     Serial.println(F(<span class="stringliteral">&quot;STOP&quot;</span>));      <span class="keywordflow">break</span>;</div><div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;        <span class="keywordflow">case</span> ACCESSORIES_MOVE_LEFT:     Serial.println(F(<span class="stringliteral">&quot;LEFT&quot;</span>));      <span class="keywordflow">break</span>;</div><div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;        <span class="keywordflow">case</span> ACCESSORIES_MOVE_RIGHT:        Serial.println(F(<span class="stringliteral">&quot;RIGHT&quot;</span>));     <span class="keywordflow">break</span>;</div><div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;        <span class="keywordflow">case</span> ACCESSORIES_MOVE_CENTER:   Serial.println(F(<span class="stringliteral">&quot;CENTER&quot;</span>));    <span class="keywordflow">break</span>;</div><div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;        <span class="keywordflow">case</span> ACCESSORIES_MOVE_TOP:      Serial.println(F(<span class="stringliteral">&quot;TOP&quot;</span>));       <span class="keywordflow">break</span>;</div><div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;        <span class="keywordflow">case</span> ACCESSORIES_MOVE_BOTTOM:   Serial.println(F(<span class="stringliteral">&quot;BOTTOM&quot;</span>));    <span class="keywordflow">break</span>;</div><div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;        <span class="keywordflow">case</span> ACCESSORIES_MOVE_STRAIGHT: Serial.println(F(<span class="stringliteral">&quot;STRAIGHT&quot;</span>));  <span class="keywordflow">break</span>;</div><div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;        <span class="keywordflow">case</span> ACCESSORIES_MOVE_DIVERGE:  Serial.println(F(<span class="stringliteral">&quot;DIVERGE&quot;</span>));   <span class="keywordflow">break</span>;</div><div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;        <span class="keywordflow">case</span> ACCESSORIES_MOVE_ON:       Serial.println(F(<span class="stringliteral">&quot;ON&quot;</span>));        <span class="keywordflow">break</span>;</div><div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;        <span class="keywordflow">case</span> ACCESSORIES_MOVE_OFF:      Serial.println(F(<span class="stringliteral">&quot;OFF&quot;</span>));       <span class="keywordflow">break</span>;</div><div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;        }</div><div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;        <span class="keywordflow">break</span>;</div><div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;    <span class="keywordflow">case</span> ACCESSORIES_EVENT_MOVEPOSITION:</div><div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;        Serial.print(F(<span class="stringliteral">&quot;MOVEPOSITION : &quot;</span>));</div><div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;        Serial.println(inEventData, DEC);</div><div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;        <span class="keywordflow">break</span>;</div><div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;    <span class="keywordflow">case</span> ACCESSORIES_EVENT_MOVEPOSITIONID:</div><div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;        Serial.println(F(<span class="stringliteral">&quot;MOVEPOSITIONID &quot;</span>));</div><div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;        <span class="keywordflow">break</span>;</div><div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;    <span class="keywordflow">case</span> ACCESSORIES_EVENT_MOVEPOSITIONINDEX:</div><div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;        Serial.print(F(<span class="stringliteral">&quot;MOVEPOSITIONINDEX : &quot;</span>));</div><div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;        Serial.println(inEventData, DEC);</div><div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;        <span class="keywordflow">break</span>;</div><div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;    <span class="keywordflow">case</span> ACCESSORIES_EVENT_CONFIG:</div><div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;        Serial.print(F(<span class="stringliteral">&quot;CONFIG : &quot;</span>));</div><div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;        Serial.print(ACCESSORIESCONFIGADDRESS(inEventData), DEC);</div><div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;        Serial.print(F(<span class="stringliteral">&quot; / &quot;</span>));</div><div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;        Serial.println(ACCESSORIESCONFIGVALUE(inEventData), DEC);</div><div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;        <span class="keywordflow">break</span>;</div><div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;    <span class="comment">//case ACCESSORIES_EVENT_SETSPEED:</span></div><div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;    <span class="comment">//case ACCESSORIES_EVENT_SETSTARTPOSITION:</span></div><div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;    <span class="keywordflow">default</span>:</div><div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;        <span class="keywordflow">break</span>;</div><div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;    }</div><div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;}</div><div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160;</div><div class="line"><a name="l00109"></a><span class="lineno"><a class="line" href="classAccessories.html#a9e5545dc9783adf1b05c0c2427016d17">  109</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="classAccessories.html#a9e5545dc9783adf1b05c0c2427016d17">Accessories::RaiseEvent</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> inId, ACCESSORIES_EVENT_TYPE inEvent, <span class="keywordtype">int</span> inData)</div><div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;{</div><div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;    <a class="code" href="classAccessories.html#a9b31341ccfe6330dc5567f7163b25761">ReceiveEvent</a>(inId, inEvent, inData);</div><div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;}</div><div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;</div><div class="line"><a name="l00114"></a><span class="lineno"><a class="line" href="classAccessories.html#a9b31341ccfe6330dc5567f7163b25761">  114</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="classAccessories.html#a9b31341ccfe6330dc5567f7163b25761">Accessories::ReceiveEvent</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> inId, ACCESSORIES_EVENT_TYPE inEventType, <span class="keywordtype">int</span> inEventData)</div><div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160;{</div><div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;<span class="preprocessor">#ifdef VISUALSTUDIO</span></div><div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160;    ArduiEmulator::ArduinoForm::_eventLog(<span class="stringliteral">&quot;Received&quot;</span>, inId, inEventType, inEventData);</div><div class="line"><a name="l00118"></a><span class="lineno">  118</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160;</div><div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160;    <a class="code" href="classAccessory.html#a6cf36c65d1519eb7e5a6aac1cba7fe51">Accessory::ExecuteEvent</a>(inId, inEventType, inEventData);</div><div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;<span class="preprocessor">#ifndef NO_GROUP</span></div><div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160;    <a class="code" href="classAccessoryGroup.html#ab9322f8e1511e5545bbd4bee7077291d">AccessoryGroup::EventAll</a>(inId, inEventType, inEventData);</div><div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;}</div><div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160;</div><div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160;<span class="preprocessor">#ifdef ACCESSORIES_PRINT_ACCESSORIES</span></div><div class="line"><a name="l00127"></a><span class="lineno">  127</span>&#160;<span class="keywordtype">void</span> Accessories::printAccessories()</div><div class="line"><a name="l00128"></a><span class="lineno">  128</span>&#160;{</div><div class="line"><a name="l00129"></a><span class="lineno">  129</span>&#160;    Serial.println(F(<span class="stringliteral">&quot;********* Accessories List&quot;</span>));</div><div class="line"><a name="l00130"></a><span class="lineno">  130</span>&#160;    <a class="code" href="classAccessory.html">Accessory</a> *pCurr = <a class="code" href="classAccessory.html#ab89d2b99293b24e6ccc38938384563f2">Accessory::GetFirstAccessory</a>();</div><div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160;</div><div class="line"><a name="l00132"></a><span class="lineno">  132</span>&#160;    <span class="keywordflow">while</span> (pCurr != NULL)</div><div class="line"><a name="l00133"></a><span class="lineno">  133</span>&#160;    {</div><div class="line"><a name="l00134"></a><span class="lineno">  134</span>&#160;        pCurr-&gt;printAccessory();</div><div class="line"><a name="l00135"></a><span class="lineno">  135</span>&#160;        pCurr = pCurr-&gt;<a class="code" href="classAccessory.html#aa27a04b9e2a95729e491598cb34c6e47">GetNextAccessory</a>();</div><div class="line"><a name="l00136"></a><span class="lineno">  136</span>&#160;    }</div><div class="line"><a name="l00137"></a><span class="lineno">  137</span>&#160;    Serial.println(F(<span class="stringliteral">&quot;********* End of Accessories&quot;</span>));</div><div class="line"><a name="l00138"></a><span class="lineno">  138</span>&#160;</div><div class="line"><a name="l00139"></a><span class="lineno">  139</span>&#160;    Serial.println(F(<span class="stringliteral">&quot;********* Groups&quot;</span>));</div><div class="line"><a name="l00140"></a><span class="lineno">  140</span>&#160;    AccessoryGroup::printGroups();</div><div class="line"><a name="l00141"></a><span class="lineno">  141</span>&#160;    Serial.println(F(<span class="stringliteral">&quot;********* End of groups&quot;</span>));</div><div class="line"><a name="l00142"></a><span class="lineno">  142</span>&#160;}</div><div class="line"><a name="l00143"></a><span class="lineno">  143</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00144"></a><span class="lineno">  144</span>&#160;</div><div class="line"><a name="l00145"></a><span class="lineno">  145</span>&#160;<span class="keyword">static</span> <a class="code" href="classAccessory.html">Accessory</a> *pLoopAccessory = NULL;</div><div class="line"><a name="l00146"></a><span class="lineno">  146</span>&#160;</div><div class="line"><a name="l00147"></a><span class="lineno"><a class="line" href="classAccessories.html#a2d5536f4566bf3475f1d446802129790">  147</a></span>&#160;<span class="keywordtype">bool</span> <a class="code" href="classAccessories.html#a2d5536f4566bf3475f1d446802129790">Accessories::loop</a>()</div><div class="line"><a name="l00148"></a><span class="lineno">  148</span>&#160;{</div><div class="line"><a name="l00149"></a><span class="lineno">  149</span>&#160;<span class="preprocessor">#ifndef NO_GROUP</span></div><div class="line"><a name="l00150"></a><span class="lineno">  150</span>&#160;    <a class="code" href="classAccessoryGroup.html#a4e51991ec66066df63057550b79febd9">AccessoryGroup::loops</a>();</div><div class="line"><a name="l00151"></a><span class="lineno">  151</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00152"></a><span class="lineno">  152</span>&#160;</div><div class="line"><a name="l00153"></a><span class="lineno">  153</span>&#160;    <span class="keywordflow">if</span> (pLoopAccessory == NULL)</div><div class="line"><a name="l00154"></a><span class="lineno">  154</span>&#160;    {</div><div class="line"><a name="l00155"></a><span class="lineno">  155</span>&#160;<span class="preprocessor">#ifdef ACCESSORIES_DEBUG_MODE</span></div><div class="line"><a name="l00156"></a><span class="lineno">  156</span>&#160;        Serial.println(F(<span class="stringliteral">&quot;*** Setup Accessories Finished.&quot;</span>));</div><div class="line"><a name="l00157"></a><span class="lineno">  157</span>&#160;</div><div class="line"><a name="l00158"></a><span class="lineno">  158</span>&#160;        <a class="code" href="classAccessory.html">Accessory</a> *pCurr = <a class="code" href="classAccessory.html#ab89d2b99293b24e6ccc38938384563f2">Accessory::GetFirstAccessory</a>();</div><div class="line"><a name="l00159"></a><span class="lineno">  159</span>&#160;</div><div class="line"><a name="l00160"></a><span class="lineno">  160</span>&#160;        <span class="keywordflow">while</span> (pCurr != NULL)</div><div class="line"><a name="l00161"></a><span class="lineno">  161</span>&#160;        {</div><div class="line"><a name="l00162"></a><span class="lineno">  162</span>&#160;            pCurr-&gt;CheckPort();</div><div class="line"><a name="l00163"></a><span class="lineno">  163</span>&#160;            pCurr = pCurr-&gt;<a class="code" href="classAccessory.html#aa27a04b9e2a95729e491598cb34c6e47">GetNextAccessory</a>();</div><div class="line"><a name="l00164"></a><span class="lineno">  164</span>&#160;        }</div><div class="line"><a name="l00165"></a><span class="lineno">  165</span>&#160;</div><div class="line"><a name="l00166"></a><span class="lineno">  166</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00167"></a><span class="lineno">  167</span>&#160;        pLoopAccessory = <a class="code" href="classAccessory.html#ab89d2b99293b24e6ccc38938384563f2">Accessory::GetFirstAccessory</a>();</div><div class="line"><a name="l00168"></a><span class="lineno">  168</span>&#160;</div><div class="line"><a name="l00169"></a><span class="lineno">  169</span>&#160;<span class="preprocessor">#ifndef NO_EEPROM</span></div><div class="line"><a name="l00170"></a><span class="lineno">  170</span>&#160;        <span class="comment">// Do not take account of the modified states during setup !</span></div><div class="line"><a name="l00171"></a><span class="lineno">  171</span>&#160;        EEPROMStartingDelay = 0;</div><div class="line"><a name="l00172"></a><span class="lineno">  172</span>&#160;</div><div class="line"><a name="l00173"></a><span class="lineno">  173</span>&#160;<span class="preprocessor">#ifdef ACCESSORIES_DEBUG_MODE</span></div><div class="line"><a name="l00174"></a><span class="lineno">  174</span>&#160;        <span class="keywordtype">bool</span> good = Accessories::EEPROMLoad();</div><div class="line"><a name="l00175"></a><span class="lineno">  175</span>&#160;        <span class="keywordflow">if</span> (!good)</div><div class="line"><a name="l00176"></a><span class="lineno">  176</span>&#160;            Serial.println(F(<span class="stringliteral">&quot;EEPROM loading aborted !&quot;</span>));</div><div class="line"><a name="l00177"></a><span class="lineno">  177</span>&#160;<span class="preprocessor">#else</span></div><div class="line"><a name="l00178"></a><span class="lineno">  178</span>&#160;        Accessories::EEPROMLoad();</div><div class="line"><a name="l00179"></a><span class="lineno">  179</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00180"></a><span class="lineno">  180</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00181"></a><span class="lineno">  181</span>&#160;    }</div><div class="line"><a name="l00182"></a><span class="lineno">  182</span>&#160;    <span class="keywordflow">else</span></div><div class="line"><a name="l00183"></a><span class="lineno">  183</span>&#160;    {</div><div class="line"><a name="l00184"></a><span class="lineno">  184</span>&#160;        <span class="keywordflow">if</span> (pLoopAccessory-&gt;<a class="code" href="classAccessory.html#aa27a04b9e2a95729e491598cb34c6e47">GetNextAccessory</a>() == NULL)</div><div class="line"><a name="l00185"></a><span class="lineno">  185</span>&#160;            pLoopAccessory = <a class="code" href="classAccessory.html#ab89d2b99293b24e6ccc38938384563f2">Accessory::GetFirstAccessory</a>();</div><div class="line"><a name="l00186"></a><span class="lineno">  186</span>&#160;        <span class="keywordflow">else</span></div><div class="line"><a name="l00187"></a><span class="lineno">  187</span>&#160;            pLoopAccessory = pLoopAccessory-&gt;<a class="code" href="classAccessory.html#aa27a04b9e2a95729e491598cb34c6e47">GetNextAccessory</a>();</div><div class="line"><a name="l00188"></a><span class="lineno">  188</span>&#160;    }</div><div class="line"><a name="l00189"></a><span class="lineno">  189</span>&#160;</div><div class="line"><a name="l00190"></a><span class="lineno">  190</span>&#160;    <span class="keywordflow">if</span> (pLoopAccessory == NULL)</div><div class="line"><a name="l00191"></a><span class="lineno">  191</span>&#160;        <span class="keywordflow">return</span> <span class="keyword">false</span>;</div><div class="line"><a name="l00192"></a><span class="lineno">  192</span>&#160;</div><div class="line"><a name="l00193"></a><span class="lineno">  193</span>&#160;    pLoopAccessory-&gt;<a class="code" href="classAccessory.html#a5891e60944d8542a8bd1eb8862e5010e">loop</a>();</div><div class="line"><a name="l00194"></a><span class="lineno">  194</span>&#160;</div><div class="line"><a name="l00195"></a><span class="lineno">  195</span>&#160;    <span class="comment">// Look for action stack pending...</span></div><div class="line"><a name="l00196"></a><span class="lineno">  196</span>&#160;    <span class="keywordflow">if</span> (<a class="code" href="classAccessory.html#ae4efeb5b525027d5ccb692f0560a3474">Accessory::IsActionPending</a>())</div><div class="line"><a name="l00197"></a><span class="lineno">  197</span>&#160;        <span class="keywordflow">return</span> <span class="keyword">true</span>;</div><div class="line"><a name="l00198"></a><span class="lineno">  198</span>&#160;</div><div class="line"><a name="l00199"></a><span class="lineno">  199</span>&#160;    <a class="code" href="classAction.html">Action</a> *act = <a class="code" href="classActionsStack.html#a458994617bfbd0f8aee0fb93abcdb347">ActionsStack::Actions</a>.<a class="code" href="classActionsStack.html#ae5e923c8c890313fe9fe67fae9497562">GetActionToExecute</a>();</div><div class="line"><a name="l00200"></a><span class="lineno">  200</span>&#160;    <span class="keywordflow">if</span> (act != NULL)</div><div class="line"><a name="l00201"></a><span class="lineno">  201</span>&#160;        <a class="code" href="classAccessory.html#a6cf36c65d1519eb7e5a6aac1cba7fe51">Accessory::ExecuteEvent</a>(act-&gt;<a class="code" href="classAction.html#a0eb90dc3ae0778c2ed16b8d6c7e5efa3">Id</a>, act-&gt;<a class="code" href="classAction.html#a1de2f13560626eab35087eb3aa67be11">Event</a>, act-&gt;<a class="code" href="classAction.html#a859b26dbab009b77f3d8c7902fd2d89b">Data</a>);</div><div class="line"><a name="l00202"></a><span class="lineno">  202</span>&#160;</div><div class="line"><a name="l00203"></a><span class="lineno">  203</span>&#160;    <span class="comment">// If nothing more to do, Save EEPROM if needed.</span></div><div class="line"><a name="l00204"></a><span class="lineno">  204</span>&#160;</div><div class="line"><a name="l00205"></a><span class="lineno">  205</span>&#160;<span class="preprocessor">#ifndef NO_EEPROM</span></div><div class="line"><a name="l00206"></a><span class="lineno">  206</span>&#160;    <span class="keywordflow">if</span> (EEPROMStartingDelay &gt; 0)</div><div class="line"><a name="l00207"></a><span class="lineno">  207</span>&#160;        EEPROMSaveRaw();</div><div class="line"><a name="l00208"></a><span class="lineno">  208</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00209"></a><span class="lineno">  209</span>&#160;</div><div class="line"><a name="l00210"></a><span class="lineno">  210</span>&#160;    <span class="keywordflow">return</span> <span class="keyword">false</span>;</div><div class="line"><a name="l00211"></a><span class="lineno">  211</span>&#160;}</div><div class="line"><a name="l00212"></a><span class="lineno">  212</span>&#160;</div><div class="line"><a name="l00213"></a><span class="lineno"><a class="line" href="classAccessories.html#aa99c21da1122ed8ef378c80149b0e68b">  213</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="classAccessories.html#aa99c21da1122ed8ef378c80149b0e68b">Accessories::wait</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> inWaitDelay)</div><div class="line"><a name="l00214"></a><span class="lineno">  214</span>&#160;{</div><div class="line"><a name="l00215"></a><span class="lineno">  215</span>&#160;    <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> start = millis();</div><div class="line"><a name="l00216"></a><span class="lineno">  216</span>&#160;    <span class="keywordflow">while</span> (millis() &lt; start + inWaitDelay)</div><div class="line"><a name="l00217"></a><span class="lineno">  217</span>&#160;        <a class="code" href="classAccessories.html#a2d5536f4566bf3475f1d446802129790">Accessories::loop</a>();</div><div class="line"><a name="l00218"></a><span class="lineno">  218</span>&#160;}</div><div class="line"><a name="l00219"></a><span class="lineno">  219</span>&#160;</div><div class="line"><a name="l00220"></a><span class="lineno">  220</span>&#160;<span class="preprocessor">#ifndef NO_EEPROM</span></div><div class="line"><a name="l00221"></a><span class="lineno">  221</span>&#160;</div><div class="line"><a name="l00222"></a><span class="lineno">  222</span>&#160;<span class="comment">/*  EEPROM format</span></div><div class="line"><a name="l00223"></a><span class="lineno">  223</span>&#160;<span class="comment"></span></div><div class="line"><a name="l00224"></a><span class="lineno">  224</span>&#160;<span class="comment">The EEPROM area starting from EEPROMStart, will be filled with the current version number (a byte), </span></div><div class="line"><a name="l00225"></a><span class="lineno">  225</span>&#160;<span class="comment">and the total number of accessories and groups. The fourth byte will be the checksum of the three</span></div><div class="line"><a name="l00226"></a><span class="lineno">  226</span>&#160;<span class="comment">starting bytes...</span></div><div class="line"><a name="l00227"></a><span class="lineno">  227</span>&#160;<span class="comment">If any of these four bytes are different from the actual values, the EEPROM will be considered as free.</span></div><div class="line"><a name="l00228"></a><span class="lineno">  228</span>&#160;<span class="comment">Two bytes are then added to store the size of one complete record, in order to be able to configurate the CircularBuffer.</span></div><div class="line"><a name="l00229"></a><span class="lineno">  229</span>&#160;<span class="comment"></span></div><div class="line"><a name="l00230"></a><span class="lineno">  230</span>&#160;<span class="comment">Following these bytes, there is the CircularBuffer of accessories.</span></div><div class="line"><a name="l00231"></a><span class="lineno">  231</span>&#160;<span class="comment">For each one the current state, the current position and the current speed will be saved.</span></div><div class="line"><a name="l00232"></a><span class="lineno">  232</span>&#160;<span class="comment">After that, each group save its current item id.</span></div><div class="line"><a name="l00233"></a><span class="lineno">  233</span>&#160;<span class="comment"></span></div><div class="line"><a name="l00234"></a><span class="lineno">  234</span>&#160;<span class="comment">                        +-+</span></div><div class="line"><a name="l00235"></a><span class="lineno">  235</span>&#160;<span class="comment">Version                 |V|</span></div><div class="line"><a name="l00236"></a><span class="lineno">  236</span>&#160;<span class="comment">Accessory number        |A|</span></div><div class="line"><a name="l00237"></a><span class="lineno">  237</span>&#160;<span class="comment">Group number            |G|</span></div><div class="line"><a name="l00238"></a><span class="lineno">  238</span>&#160;<span class="comment">header checksum         |C|</span></div><div class="line"><a name="l00239"></a><span class="lineno">  239</span>&#160;<span class="comment">size byte 1             |s1]</span></div><div class="line"><a name="l00240"></a><span class="lineno">  240</span>&#160;<span class="comment">size byte 2             |s2]</span></div><div class="line"><a name="l00241"></a><span class="lineno">  241</span>&#160;<span class="comment">                        +-+</span></div><div class="line"><a name="l00242"></a><span class="lineno">  242</span>&#160;<span class="comment">Circular buffer         | |</span></div><div class="line"><a name="l00243"></a><span class="lineno">  243</span>&#160;<span class="comment">                        +-+</span></div><div class="line"><a name="l00244"></a><span class="lineno">  244</span>&#160;<span class="comment">                    End of file.</span></div><div class="line"><a name="l00245"></a><span class="lineno">  245</span>&#160;<span class="comment"></span></div><div class="line"><a name="l00246"></a><span class="lineno">  246</span>&#160;<span class="comment">One record of the Circular buffer is :</span></div><div class="line"><a name="l00247"></a><span class="lineno">  247</span>&#160;<span class="comment"></span></div><div class="line"><a name="l00248"></a><span class="lineno">  248</span>&#160;<span class="comment">                        +-+</span></div><div class="line"><a name="l00249"></a><span class="lineno">  249</span>&#160;<span class="comment">Acc 1 : State           |S|</span></div><div class="line"><a name="l00250"></a><span class="lineno">  250</span>&#160;<span class="comment">Acc 1 : Position        |P|</span></div><div class="line"><a name="l00251"></a><span class="lineno">  251</span>&#160;<span class="comment">Acc 1 : Speed           |s|</span></div><div class="line"><a name="l00252"></a><span class="lineno">  252</span>&#160;<span class="comment">                        +-+</span></div><div class="line"><a name="l00253"></a><span class="lineno">  253</span>&#160;<span class="comment">Acc 2 : State           |S|</span></div><div class="line"><a name="l00254"></a><span class="lineno">  254</span>&#160;<span class="comment">Acc 2 : Position        |P|</span></div><div class="line"><a name="l00255"></a><span class="lineno">  255</span>&#160;<span class="comment">Acc 2 : Speed           |s|</span></div><div class="line"><a name="l00256"></a><span class="lineno">  256</span>&#160;<span class="comment">                        +-+                 </span></div><div class="line"><a name="l00257"></a><span class="lineno">  257</span>&#160;<span class="comment">Acc 3 : State           |S|</span></div><div class="line"><a name="l00258"></a><span class="lineno">  258</span>&#160;<span class="comment">Acc 3 : Position        |P|</span></div><div class="line"><a name="l00259"></a><span class="lineno">  259</span>&#160;<span class="comment">Acc 3 : Speed           |s|</span></div><div class="line"><a name="l00260"></a><span class="lineno">  260</span>&#160;<span class="comment">...                     +-+</span></div><div class="line"><a name="l00261"></a><span class="lineno">  261</span>&#160;<span class="comment">Group 1 : current ID    |I|</span></div><div class="line"><a name="l00262"></a><span class="lineno">  262</span>&#160;<span class="comment">Group 3 : current ID    |I|</span></div><div class="line"><a name="l00263"></a><span class="lineno">  263</span>&#160;<span class="comment">Group 3 : current ID    |I|</span></div><div class="line"><a name="l00264"></a><span class="lineno">  264</span>&#160;<span class="comment">                        +-+</span></div><div class="line"><a name="l00265"></a><span class="lineno">  265</span>&#160;<span class="comment">                    End of record.</span></div><div class="line"><a name="l00266"></a><span class="lineno">  266</span>&#160;<span class="comment">*/</span></div><div class="line"><a name="l00267"></a><span class="lineno">  267</span>&#160;</div><div class="line"><a name="l00268"></a><span class="lineno">  268</span>&#160;<span class="comment">// this version is used to know if the form have changed. During reloading, if the version is not equal to the </span></div><div class="line"><a name="l00269"></a><span class="lineno">  269</span>&#160;<span class="comment">// actual version EEPROM_VERSION, the file will be considered as empty !</span></div><div class="line"><a name="l00270"></a><span class="lineno">  270</span>&#160;<span class="preprocessor">#define EEPROM_VERSION  0</span></div><div class="line"><a name="l00271"></a><span class="lineno">  271</span>&#160;</div><div class="line"><a name="l00272"></a><span class="lineno">  272</span>&#160;<span class="keywordtype">void</span> Accessories::EEPROMSave()</div><div class="line"><a name="l00273"></a><span class="lineno">  273</span>&#160;{</div><div class="line"><a name="l00274"></a><span class="lineno">  274</span>&#160;    <span class="keywordflow">if</span> (EEPROMStart == -1 || EEPROMSize == -1)</div><div class="line"><a name="l00275"></a><span class="lineno">  275</span>&#160;        <span class="keywordflow">return</span>;</div><div class="line"><a name="l00276"></a><span class="lineno">  276</span>&#160;</div><div class="line"><a name="l00277"></a><span class="lineno">  277</span>&#160;    <span class="keywordflow">if</span> (EEPROMStartingDelay == 0)</div><div class="line"><a name="l00278"></a><span class="lineno">  278</span>&#160;        EEPROMStartingDelay = millis();</div><div class="line"><a name="l00279"></a><span class="lineno">  279</span>&#160;}</div><div class="line"><a name="l00280"></a><span class="lineno">  280</span>&#160;</div><div class="line"><a name="l00281"></a><span class="lineno">  281</span>&#160;<span class="keywordtype">void</span> Accessories::EEPROMSaveRaw()</div><div class="line"><a name="l00282"></a><span class="lineno">  282</span>&#160;{</div><div class="line"><a name="l00283"></a><span class="lineno">  283</span>&#160;    <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> mill = millis();</div><div class="line"><a name="l00284"></a><span class="lineno">  284</span>&#160;    <span class="keywordflow">if</span> (mill - EEPROMStartingDelay &lt; EEPROM_SAVE_DELAY)</div><div class="line"><a name="l00285"></a><span class="lineno">  285</span>&#160;        <span class="keywordflow">return</span>;</div><div class="line"><a name="l00286"></a><span class="lineno">  286</span>&#160;</div><div class="line"><a name="l00287"></a><span class="lineno">  287</span>&#160;    <span class="keywordtype">int</span> pos = EEPROMStart;</div><div class="line"><a name="l00288"></a><span class="lineno">  288</span>&#160;</div><div class="line"><a name="l00289"></a><span class="lineno">  289</span>&#160;    uint8_t accCount = <a class="code" href="classAccessory.html#af8b0920b2a419e278fbc79e3fcc75f86">Accessory::GetCount</a>();</div><div class="line"><a name="l00290"></a><span class="lineno">  290</span>&#160;    uint8_t grpCount = <a class="code" href="classAccessoryGroup.html#a5c852b40b4303445aaf77bfd03095b1f">AccessoryGroup::GetCount</a>();</div><div class="line"><a name="l00291"></a><span class="lineno">  291</span>&#160;</div><div class="line"><a name="l00292"></a><span class="lineno">  292</span>&#160;    EEPROM.update(pos++, EEPROM_VERSION);</div><div class="line"><a name="l00293"></a><span class="lineno">  293</span>&#160;    EEPROM.update(pos++, accCount);</div><div class="line"><a name="l00294"></a><span class="lineno">  294</span>&#160;    EEPROM.update(pos++, grpCount);</div><div class="line"><a name="l00295"></a><span class="lineno">  295</span>&#160;</div><div class="line"><a name="l00296"></a><span class="lineno">  296</span>&#160;    EEPROM.update(pos++, EEPROMSize / 256);</div><div class="line"><a name="l00297"></a><span class="lineno">  297</span>&#160;    EEPROM.update(pos++, EEPROMSize % 256);</div><div class="line"><a name="l00298"></a><span class="lineno">  298</span>&#160;</div><div class="line"><a name="l00299"></a><span class="lineno">  299</span>&#160;    <span class="keywordflow">if</span> (EEPROMRecordSize == 0)</div><div class="line"><a name="l00300"></a><span class="lineno">  300</span>&#160;    {</div><div class="line"><a name="l00301"></a><span class="lineno">  301</span>&#160;        <span class="comment">// Compute the size to save it for the first time.</span></div><div class="line"><a name="l00302"></a><span class="lineno">  302</span>&#160;        <a class="code" href="classAccessory.html">Accessory</a> *pCurr = <a class="code" href="classAccessory.html#ab89d2b99293b24e6ccc38938384563f2">Accessory::GetFirstAccessory</a>();</div><div class="line"><a name="l00303"></a><span class="lineno">  303</span>&#160;</div><div class="line"><a name="l00304"></a><span class="lineno">  304</span>&#160;        <span class="keywordflow">while</span> (pCurr != NULL)</div><div class="line"><a name="l00305"></a><span class="lineno">  305</span>&#160;        {</div><div class="line"><a name="l00306"></a><span class="lineno">  306</span>&#160;            EEPROMRecordSize = pCurr-&gt;<a class="code" href="classAccessory.html#a49f289549f486e8307ec06123939ca40">EEPROMSave</a>(EEPROMRecordSize, <span class="keyword">true</span>);</div><div class="line"><a name="l00307"></a><span class="lineno">  307</span>&#160;            pCurr = pCurr-&gt;<a class="code" href="classAccessory.html#aa27a04b9e2a95729e491598cb34c6e47">GetNextAccessory</a>();</div><div class="line"><a name="l00308"></a><span class="lineno">  308</span>&#160;        }</div><div class="line"><a name="l00309"></a><span class="lineno">  309</span>&#160;</div><div class="line"><a name="l00310"></a><span class="lineno">  310</span>&#160;        EEPROMRecordSize = <a class="code" href="classAccessoryGroup.html#a414d80944dab2b6ee852fac72e2139d7">AccessoryGroup::EEPROMSaveAll</a>(EEPROMRecordSize, <span class="keyword">true</span>);</div><div class="line"><a name="l00311"></a><span class="lineno">  311</span>&#160;</div><div class="line"><a name="l00312"></a><span class="lineno">  312</span>&#160;        circularBuffer.begin(pos+3, EEPROMRecordSize, (EEPROMSize - 10) / EEPROMRecordSize);</div><div class="line"><a name="l00313"></a><span class="lineno">  313</span>&#160;        circularBuffer.clear();</div><div class="line"><a name="l00314"></a><span class="lineno">  314</span>&#160;    }</div><div class="line"><a name="l00315"></a><span class="lineno">  315</span>&#160;</div><div class="line"><a name="l00316"></a><span class="lineno">  316</span>&#160;    EEPROM.update(pos++, EEPROMRecordSize / 256);</div><div class="line"><a name="l00317"></a><span class="lineno">  317</span>&#160;    EEPROM.update(pos++, EEPROMRecordSize % 256);</div><div class="line"><a name="l00318"></a><span class="lineno">  318</span>&#160;</div><div class="line"><a name="l00319"></a><span class="lineno">  319</span>&#160;    EEPROM.update(pos++, (uint8_t) (EEPROM_VERSION + accCount + grpCount + EEPROMSize + EEPROMRecordSize));</div><div class="line"><a name="l00320"></a><span class="lineno">  320</span>&#160;</div><div class="line"><a name="l00321"></a><span class="lineno">  321</span>&#160;    pos = circularBuffer.startWrite();</div><div class="line"><a name="l00322"></a><span class="lineno">  322</span>&#160;    <a class="code" href="classAccessory.html">Accessory</a> *pCurr = <a class="code" href="classAccessory.html#ab89d2b99293b24e6ccc38938384563f2">Accessory::GetFirstAccessory</a>();</div><div class="line"><a name="l00323"></a><span class="lineno">  323</span>&#160;</div><div class="line"><a name="l00324"></a><span class="lineno">  324</span>&#160;    <span class="keywordflow">while</span> (pCurr != NULL)</div><div class="line"><a name="l00325"></a><span class="lineno">  325</span>&#160;    {</div><div class="line"><a name="l00326"></a><span class="lineno">  326</span>&#160;        pos = pCurr-&gt;<a class="code" href="classAccessory.html#a49f289549f486e8307ec06123939ca40">EEPROMSave</a>(pos);</div><div class="line"><a name="l00327"></a><span class="lineno">  327</span>&#160;        pCurr = pCurr-&gt;<a class="code" href="classAccessory.html#aa27a04b9e2a95729e491598cb34c6e47">GetNextAccessory</a>();</div><div class="line"><a name="l00328"></a><span class="lineno">  328</span>&#160;    }</div><div class="line"><a name="l00329"></a><span class="lineno">  329</span>&#160;</div><div class="line"><a name="l00330"></a><span class="lineno">  330</span>&#160;    pos = <a class="code" href="classAccessoryGroup.html#a414d80944dab2b6ee852fac72e2139d7">AccessoryGroup::EEPROMSaveAll</a>(pos);</div><div class="line"><a name="l00331"></a><span class="lineno">  331</span>&#160;    EEPROMStartingDelay = 0;</div><div class="line"><a name="l00332"></a><span class="lineno">  332</span>&#160;}</div><div class="line"><a name="l00333"></a><span class="lineno">  333</span>&#160;</div><div class="line"><a name="l00334"></a><span class="lineno">  334</span>&#160;<span class="keywordtype">bool</span> Accessories::EEPROMLoad()</div><div class="line"><a name="l00335"></a><span class="lineno">  335</span>&#160;{</div><div class="line"><a name="l00336"></a><span class="lineno">  336</span>&#160;    <span class="keywordflow">if</span> (EEPROMStart == -1 || EEPROMSize == -1)</div><div class="line"><a name="l00337"></a><span class="lineno">  337</span>&#160;        <span class="keywordflow">return</span> <span class="keyword">false</span>;</div><div class="line"><a name="l00338"></a><span class="lineno">  338</span>&#160;</div><div class="line"><a name="l00339"></a><span class="lineno">  339</span>&#160;    <span class="keywordtype">int</span> pos = EEPROMStart;</div><div class="line"><a name="l00340"></a><span class="lineno">  340</span>&#160;    uint8_t accCount = <a class="code" href="classAccessory.html#af8b0920b2a419e278fbc79e3fcc75f86">Accessory::GetCount</a>();</div><div class="line"><a name="l00341"></a><span class="lineno">  341</span>&#160;    uint8_t grpCount = <a class="code" href="classAccessoryGroup.html#a5c852b40b4303445aaf77bfd03095b1f">AccessoryGroup::GetCount</a>();</div><div class="line"><a name="l00342"></a><span class="lineno">  342</span>&#160;</div><div class="line"><a name="l00343"></a><span class="lineno">  343</span>&#160;    <span class="keywordflow">if</span> (EEPROM.read(pos++) != EEPROM_VERSION)</div><div class="line"><a name="l00344"></a><span class="lineno">  344</span>&#160;        <span class="keywordflow">return</span> <span class="keyword">false</span>;</div><div class="line"><a name="l00345"></a><span class="lineno">  345</span>&#160;</div><div class="line"><a name="l00346"></a><span class="lineno">  346</span>&#160;    <span class="keywordflow">if</span> (EEPROM.read(pos++) != accCount)</div><div class="line"><a name="l00347"></a><span class="lineno">  347</span>&#160;        <span class="keywordflow">return</span> <span class="keyword">false</span>;</div><div class="line"><a name="l00348"></a><span class="lineno">  348</span>&#160;</div><div class="line"><a name="l00349"></a><span class="lineno">  349</span>&#160;    <span class="keywordflow">if</span> (EEPROM.read(pos++) != grpCount)</div><div class="line"><a name="l00350"></a><span class="lineno">  350</span>&#160;        <span class="keywordflow">if</span> (EEPROM.read(pos++) != accCount)</div><div class="line"><a name="l00351"></a><span class="lineno">  351</span>&#160;            <span class="keywordflow">return</span> <span class="keyword">false</span>;</div><div class="line"><a name="l00352"></a><span class="lineno">  352</span>&#160;</div><div class="line"><a name="l00353"></a><span class="lineno">  353</span>&#160;    byte b1, b2;</div><div class="line"><a name="l00354"></a><span class="lineno">  354</span>&#160;    b1 = EEPROM.read(pos++);</div><div class="line"><a name="l00355"></a><span class="lineno">  355</span>&#160;    b2 = EEPROM.read(pos++);</div><div class="line"><a name="l00356"></a><span class="lineno">  356</span>&#160;    <span class="keywordflow">if</span> (EEPROMSize != b1 * 256 + b2)</div><div class="line"><a name="l00357"></a><span class="lineno">  357</span>&#160;        <span class="keywordflow">return</span> <span class="keyword">false</span>;</div><div class="line"><a name="l00358"></a><span class="lineno">  358</span>&#160;</div><div class="line"><a name="l00359"></a><span class="lineno">  359</span>&#160;    b1 = EEPROM.read(pos++);</div><div class="line"><a name="l00360"></a><span class="lineno">  360</span>&#160;    b2 = EEPROM.read(pos++);</div><div class="line"><a name="l00361"></a><span class="lineno">  361</span>&#160;    EEPROMRecordSize = b1 * 256 + b2;</div><div class="line"><a name="l00362"></a><span class="lineno">  362</span>&#160;</div><div class="line"><a name="l00363"></a><span class="lineno">  363</span>&#160;    <span class="keywordflow">if</span> (EEPROM.read(pos++) != (uint8_t)(EEPROM_VERSION + accCount + grpCount + EEPROMSize + EEPROMRecordSize))</div><div class="line"><a name="l00364"></a><span class="lineno">  364</span>&#160;    {</div><div class="line"><a name="l00365"></a><span class="lineno">  365</span>&#160;        EEPROMRecordSize = 0;</div><div class="line"><a name="l00366"></a><span class="lineno">  366</span>&#160;        <span class="keywordflow">return</span> <span class="keyword">false</span>;</div><div class="line"><a name="l00367"></a><span class="lineno">  367</span>&#160;    }</div><div class="line"><a name="l00368"></a><span class="lineno">  368</span>&#160;</div><div class="line"><a name="l00369"></a><span class="lineno">  369</span>&#160;    circularBuffer.begin(pos, EEPROMRecordSize, (EEPROMSize - 10) / EEPROMRecordSize);</div><div class="line"><a name="l00370"></a><span class="lineno">  370</span>&#160;</div><div class="line"><a name="l00371"></a><span class="lineno">  371</span>&#160;    <span class="comment">// Start circular buffer just after the header.</span></div><div class="line"><a name="l00372"></a><span class="lineno">  372</span>&#160;    pos = circularBuffer.getStartRead();</div><div class="line"><a name="l00373"></a><span class="lineno">  373</span>&#160;    <a class="code" href="classAccessory.html">Accessory</a> *pCurr = <a class="code" href="classAccessory.html#ab89d2b99293b24e6ccc38938384563f2">Accessory::GetFirstAccessory</a>();</div><div class="line"><a name="l00374"></a><span class="lineno">  374</span>&#160;</div><div class="line"><a name="l00375"></a><span class="lineno">  375</span>&#160;    <span class="keywordflow">while</span> (pCurr != NULL)</div><div class="line"><a name="l00376"></a><span class="lineno">  376</span>&#160;    {</div><div class="line"><a name="l00377"></a><span class="lineno">  377</span>&#160;        pos = pCurr-&gt;<a class="code" href="classAccessory.html#a245ad3bad4fa0f1d657fdc20b2edb868">EEPROMLoad</a>(pos);</div><div class="line"><a name="l00378"></a><span class="lineno">  378</span>&#160;        pCurr = pCurr-&gt;<a class="code" href="classAccessory.html#aa27a04b9e2a95729e491598cb34c6e47">GetNextAccessory</a>();</div><div class="line"><a name="l00379"></a><span class="lineno">  379</span>&#160;    }</div><div class="line"><a name="l00380"></a><span class="lineno">  380</span>&#160;</div><div class="line"><a name="l00381"></a><span class="lineno">  381</span>&#160;    pos = <a class="code" href="classAccessoryGroup.html#a0dac6d80624d22f75d7e5612f2ac34cf">AccessoryGroup::EEPROMLoadAll</a>(pos);</div><div class="line"><a name="l00382"></a><span class="lineno">  382</span>&#160;    EEPROMStartingDelay = 0;</div><div class="line"><a name="l00383"></a><span class="lineno">  383</span>&#160;</div><div class="line"><a name="l00384"></a><span class="lineno">  384</span>&#160;    <span class="keywordflow">return</span> <span class="keyword">true</span>;</div><div class="line"><a name="l00385"></a><span class="lineno">  385</span>&#160;}</div><div class="line"><a name="l00386"></a><span class="lineno">  386</span>&#160;<span class="preprocessor">#endif</span></div><div class="ttc" id="classAccessoryGroup_html_a414d80944dab2b6ee852fac72e2139d7"><div class="ttname"><a href="classAccessoryGroup.html#a414d80944dab2b6ee852fac72e2139d7">AccessoryGroup::EEPROMSaveAll</a></div><div class="ttdeci">static int EEPROMSaveAll(int inPos, bool inSimulate = false)</div></div>
<div class="ttc" id="classAccessory_html_a49f289549f486e8307ec06123939ca40"><div class="ttname"><a href="classAccessory.html#a49f289549f486e8307ec06123939ca40">Accessory::EEPROMSave</a></div><div class="ttdeci">virtual int EEPROMSave(int inPos, bool inSimulate = false)</div></div>
<div class="ttc" id="classAccessory_html_a245ad3bad4fa0f1d657fdc20b2edb868"><div class="ttname"><a href="classAccessory.html#a245ad3bad4fa0f1d657fdc20b2edb868">Accessory::EEPROMLoad</a></div><div class="ttdeci">virtual int EEPROMLoad(int inPos)</div></div>
<div class="ttc" id="classAccessories_html_a2d5536f4566bf3475f1d446802129790"><div class="ttname"><a href="classAccessories.html#a2d5536f4566bf3475f1d446802129790">Accessories::loop</a></div><div class="ttdeci">static bool loop()</div><div class="ttdef"><b>Definition:</b> <a href="Accessories_8cpp_source.html#l00147">Accessories.cpp:147</a></div></div>
<div class="ttc" id="classAccessory_html_ab89d2b99293b24e6ccc38938384563f2"><div class="ttname"><a href="classAccessory.html#ab89d2b99293b24e6ccc38938384563f2">Accessory::GetFirstAccessory</a></div><div class="ttdeci">static Accessory * GetFirstAccessory()</div><div class="ttdef"><b>Definition:</b> <a href="Accessory_8hpp_source.html#l00355">Accessory.hpp:355</a></div></div>
<div class="ttc" id="classAccessories_html_aa99c21da1122ed8ef378c80149b0e68b"><div class="ttname"><a href="classAccessories.html#aa99c21da1122ed8ef378c80149b0e68b">Accessories::wait</a></div><div class="ttdeci">static void wait(unsigned long inDelay)</div><div class="ttdef"><b>Definition:</b> <a href="Accessories_8cpp_source.html#l00213">Accessories.cpp:213</a></div></div>
<div class="ttc" id="classAccessory_html_aa27a04b9e2a95729e491598cb34c6e47"><div class="ttname"><a href="classAccessory.html#aa27a04b9e2a95729e491598cb34c6e47">Accessory::GetNextAccessory</a></div><div class="ttdeci">Accessory * GetNextAccessory() const </div><div class="ttdef"><b>Definition:</b> <a href="Accessory_8hpp_source.html#l00360">Accessory.hpp:360</a></div></div>
<div class="ttc" id="classAccessoryGroup_html_ab9322f8e1511e5545bbd4bee7077291d"><div class="ttname"><a href="classAccessoryGroup.html#ab9322f8e1511e5545bbd4bee7077291d">AccessoryGroup::EventAll</a></div><div class="ttdeci">static void EventAll(unsigned long inId, ACCESSORIES_EVENT_TYPE inEvent = ACCESSORIES_EVENT_MOVEPOSITIONID, int inData = 0)</div><div class="ttdef"><b>Definition:</b> <a href="AccessoryGroup_8cpp_source.html#l00314">AccessoryGroup.cpp:314</a></div></div>
<div class="ttc" id="classAccessory_html_a6cf36c65d1519eb7e5a6aac1cba7fe51"><div class="ttname"><a href="classAccessory.html#a6cf36c65d1519eb7e5a6aac1cba7fe51">Accessory::ExecuteEvent</a></div><div class="ttdeci">static void ExecuteEvent(unsigned long inId, ACCESSORIES_EVENT_TYPE inEvent = ACCESSORIES_EVENT_MOVEPOSITIONID, int inData = 0)</div><div class="ttdef"><b>Definition:</b> <a href="Accessory_8cpp_source.html#l00388">Accessory.cpp:388</a></div></div>
<div class="ttc" id="classAccessory_html"><div class="ttname"><a href="classAccessory.html">Accessory</a></div><div class="ttdef"><b>Definition:</b> <a href="Accessory_8hpp_source.html#l00140">Accessory.hpp:140</a></div></div>
<div class="ttc" id="classAccessories_html_abf6c53a430ca7986f9acfc5b222cbc31"><div class="ttname"><a href="classAccessories.html#abf6c53a430ca7986f9acfc5b222cbc31">Accessories::begin</a></div><div class="ttdeci">static void begin(int inEEPROMStart = -1, int inEEPROMSize = -1)</div><div class="ttdef"><b>Definition:</b> <a href="Accessories_8cpp_source.html#l00024">Accessories.cpp:24</a></div></div>
<div class="ttc" id="classAccessories_html_a9b31341ccfe6330dc5567f7163b25761"><div class="ttname"><a href="classAccessories.html#a9b31341ccfe6330dc5567f7163b25761">Accessories::ReceiveEvent</a></div><div class="ttdeci">static void ReceiveEvent(unsigned long inID, ACCESSORIES_EVENT_TYPE lastEventType, int inData)</div><div class="ttdef"><b>Definition:</b> <a href="Accessories_8cpp_source.html#l00114">Accessories.cpp:114</a></div></div>
<div class="ttc" id="classAccessories_html_a9e5545dc9783adf1b05c0c2427016d17"><div class="ttname"><a href="classAccessories.html#a9e5545dc9783adf1b05c0c2427016d17">Accessories::RaiseEvent</a></div><div class="ttdeci">static void RaiseEvent(unsigned long inId, ACCESSORIES_EVENT_TYPE inEvent = ACCESSORIES_EVENT_MOVEPOSITIONID, int inData = 0)</div><div class="ttdef"><b>Definition:</b> <a href="Accessories_8cpp_source.html#l00109">Accessories.cpp:109</a></div></div>
<div class="ttc" id="classAccessoryGroup_html_a5c852b40b4303445aaf77bfd03095b1f"><div class="ttname"><a href="classAccessoryGroup.html#a5c852b40b4303445aaf77bfd03095b1f">AccessoryGroup::GetCount</a></div><div class="ttdeci">static uint8_t GetCount()</div><div class="ttdef"><b>Definition:</b> <a href="AccessoryGroup_8cpp_source.html#l00215">AccessoryGroup.cpp:215</a></div></div>
<div class="ttc" id="classAccessoriesCircularBuffer_html"><div class="ttname"><a href="classAccessoriesCircularBuffer.html">AccessoriesCircularBuffer</a></div><div class="ttdef"><b>Definition:</b> <a href="AccessoriesCircularBuffer_8hpp_source.html#l00029">AccessoriesCircularBuffer.hpp:29</a></div></div>
<div class="ttc" id="classAction_html_a1de2f13560626eab35087eb3aa67be11"><div class="ttname"><a href="classAction.html#a1de2f13560626eab35087eb3aa67be11">Action::Event</a></div><div class="ttdeci">ACCESSORIES_EVENT_TYPE Event</div><div class="ttdef"><b>Definition:</b> <a href="ActionsStack_8hpp_source.html#l00017">ActionsStack.hpp:17</a></div></div>
<div class="ttc" id="classActionsStack_html_ae5e923c8c890313fe9fe67fae9497562"><div class="ttname"><a href="classActionsStack.html#ae5e923c8c890313fe9fe67fae9497562">ActionsStack::GetActionToExecute</a></div><div class="ttdeci">Action * GetActionToExecute()</div><div class="ttdef"><b>Definition:</b> <a href="ActionsStack_8cpp_source.html#l00045">ActionsStack.cpp:45</a></div></div>
<div class="ttc" id="classAccessoryGroup_html_a0dac6d80624d22f75d7e5612f2ac34cf"><div class="ttname"><a href="classAccessoryGroup.html#a0dac6d80624d22f75d7e5612f2ac34cf">AccessoryGroup::EEPROMLoadAll</a></div><div class="ttdeci">static int EEPROMLoadAll(int inPos)</div></div>
<div class="ttc" id="classAccessory_html_af8b0920b2a419e278fbc79e3fcc75f86"><div class="ttname"><a href="classAccessory.html#af8b0920b2a419e278fbc79e3fcc75f86">Accessory::GetCount</a></div><div class="ttdeci">static uint8_t GetCount()</div><div class="ttdef"><b>Definition:</b> <a href="Accessory_8cpp_source.html#l00233">Accessory.cpp:233</a></div></div>
<div class="ttc" id="classAccessoryGroup_html_a4e51991ec66066df63057550b79febd9"><div class="ttname"><a href="classAccessoryGroup.html#a4e51991ec66066df63057550b79febd9">AccessoryGroup::loops</a></div><div class="ttdeci">static bool loops()</div><div class="ttdef"><b>Definition:</b> <a href="AccessoryGroup_8cpp_source.html#l00294">AccessoryGroup.cpp:294</a></div></div>
<div class="ttc" id="classAccessory_html_a5891e60944d8542a8bd1eb8862e5010e"><div class="ttname"><a href="classAccessory.html#a5891e60944d8542a8bd1eb8862e5010e">Accessory::loop</a></div><div class="ttdeci">bool loop()</div><div class="ttdef"><b>Definition:</b> <a href="Accessory_8hpp_source.html#l00259">Accessory.hpp:259</a></div></div>
<div class="ttc" id="classAccessory_html_ae4efeb5b525027d5ccb692f0560a3474"><div class="ttname"><a href="classAccessory.html#ae4efeb5b525027d5ccb692f0560a3474">Accessory::IsActionPending</a></div><div class="ttdeci">static bool IsActionPending()</div><div class="ttdef"><b>Definition:</b> <a href="Accessory_8cpp_source.html#l00260">Accessory.cpp:260</a></div></div>
<div class="ttc" id="classAction_html"><div class="ttname"><a href="classAction.html">Action</a></div><div class="ttdef"><b>Definition:</b> <a href="ActionsStack_8hpp_source.html#l00011">ActionsStack.hpp:11</a></div></div>
<div class="ttc" id="classAction_html_a859b26dbab009b77f3d8c7902fd2d89b"><div class="ttname"><a href="classAction.html#a859b26dbab009b77f3d8c7902fd2d89b">Action::Data</a></div><div class="ttdeci">int Data</div><div class="ttdef"><b>Definition:</b> <a href="ActionsStack_8hpp_source.html#l00019">ActionsStack.hpp:19</a></div></div>
<div class="ttc" id="classAction_html_a0eb90dc3ae0778c2ed16b8d6c7e5efa3"><div class="ttname"><a href="classAction.html#a0eb90dc3ae0778c2ed16b8d6c7e5efa3">Action::Id</a></div><div class="ttdeci">unsigned long Id</div><div class="ttdef"><b>Definition:</b> <a href="ActionsStack_8hpp_source.html#l00015">ActionsStack.hpp:15</a></div></div>
<div class="ttc" id="classActionsStack_html_a458994617bfbd0f8aee0fb93abcdb347"><div class="ttname"><a href="classActionsStack.html#a458994617bfbd0f8aee0fb93abcdb347">ActionsStack::Actions</a></div><div class="ttdeci">static ActionsStack Actions</div><div class="ttdef"><b>Definition:</b> <a href="ActionsStack_8hpp_source.html#l00069">ActionsStack.hpp:69</a></div></div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<!-- Generated by DoxyPress 1.2.10 -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="dir_d41d8cd98f00b204e9800998ecf8427e.html">src</a></li><li class="navelem"><b>Accessories.cpp</b></li>
    <li class="footer">Generated on mer. oct. 18 2017 17:44:46 for Accessories &nbsp; by
    <a href="http://www.copperspice.com/documentation-doxypress.html">
    <img class="footer" src="doxypress.png" alt="DoxyPress"/></a> 1.2.10 </li>
  </ul>
</div>
</body>
</html>
